/*
 *      dvbscan.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __DVBSCAN_H__
#define __DVBSCAN_H__

#include <glib.h>

#define DVBSCAN_SECTION_HEADER_LENGTH  8
#define DVBSCAN_SECTION_CRC_LENGTH     4

#define DVBSCAN_PAT_READ_TIMEOUT       20
#define DVBSCAN_PMT_READ_TIMEOUT       5
#define DVBSCAN_SDT_READ_TIMEOUT       20
#define DVBSCAN_NIT_READ_TIMEOUT       25
#define DVBSCAN_TDT_READ_TIMEOUT       35

#define DVBSCAN_SERVICE_LANG_ID        16

enum {
	DVBSCAN_STATUS_PAT = 0,
	DVBSCAN_STATUS_PMT,
	DVBSCAN_STATUS_SDT,
	DVBSCAN_STATUS_NIT,
	DVBSCAN_STATUS_TDT,
	DVBSCAN_STATUS_NULL
};

struct _srcservice {
	gboolean sticky;
	gint     sid;
	gushort  pmt;
	gushort  pcr;
	gushort  vpid;
	gushort  svclang;
	gushort  apid[16];
	gushort  lang[16];
	gushort  caid[16];
	gushort  dpid[16];
	gushort  ttpid;
	gushort  stpid;
	gushort  ac3pid;
	guchar   type;
	guchar   status;
	gchar    *name;
	gchar    *provider;
};

struct _netentry {
	guint   frequency;
	gint    position;
	guint8  polarization;
	guint8  modulation;
	guint   sr;
	guint8  fec;
};

//GSList *dvbscan_get_services(void);
GHashTable *dvbscan_get_services(void);
GSList *dvbscan_get_netsearch(void);
gchar *dvbscan_get_network_name(void);
//time_t dvbscan_get_tptime(void);
struct tm *dvbscan_get_tptime(void);
gchar *dvbscan_get_cas_name(guint caid);
gint dvbscan_start(guint adapter, guint demux, void (status_cb)(gint status));
gboolean dvbscan_free_list(void);

#endif /* __DVBSCAN_H__ */
